/* ===========================================================================
                           TTB Plugin Template(VC++)

                                 Main.cpp

   =========================================================================== */
#include "Windows.h"

#include "Main.h"
#include "MessageDef.h"
#include <stdio.h>

// --------------------------------------------------------
//    R}h̏
// --------------------------------------------------------
#if COMMAND_COUNT > 0
PLUGIN_COMMAND_INFO	COMMAND_INFO[COMMAND_COUNT] = {
	{
		"PrintEnvironment",					// R}hipj
		"TTBase̕\",				// R}hi{j
		COMMAND1_ID,				// R}hID
		0,							// Attrigpj
		-1,							// ResTd(gpj
		dmToolMenu | dmHotKeyMenu,	
									// DispMenu
		0,							// TimerInterval[msec] 0ŎgpȂ
		0							// TimerCounterigpj
	}
};
#endif

HINSTANCE g_hInst;
unsigned long g_crcTable[256];
bool g_crcTableComputed = false;

void getOS(char *result)	//http://www.westbrook.jp/Tips/Win/OSVersion.html
{
	OSVERSIONINFO os;
	bool isNT;
	int minor;
	
	ZeroMemory(&os, sizeof(os));
	os.dwOSVersionInfoSize = sizeof(os);
	
	GetVersionEx(&os);

	if (os.dwPlatformId == VER_PLATFORM_WIN32_NT) {
		isNT = true;
	} else {
		isNT = false;
	}
	minor = os.dwMinorVersion;

	strcpy(result, "Unknown OS");

	switch (os.dwMajorVersion) {
		case 3:
			if (isNT) {
				strcpy(result, "Windows NT 3.51");
			}
			break;
		case 4:
			if (isNT) {
				strcpy(result, "Windows NT 4.0");
			} else {
				switch (minor) {
					case 10:
						strcpy(result, "Windows 98");
						break;
					case 90:
						strcpy(result, "Windows Me");
						break;
					case 0:
					default:
						strcpy(result, "Windows 95");
						break;
				}
			}
			break;
		case 5:
			switch (minor) {
				case 1:
					sprintf(result, "Windows XP %s", os.szCSDVersion);
					break;
				case 2:
					strcpy(result, "Windows Server 2003");
					break;
				case 0:
				default:
					sprintf(result, "Windows 2000 %s", os.szCSDVersion);
					break;
			}
			break;
		case 6:
			switch (minor) {
				case 1:
					strcpy(result, "Windows 7");
					break;
				case 0:
				default:
					strcpy(result, "Windows Vista");
					break;
			}
			break;
		default:
			strcpy(result, "Unknown OS");
			break;
	}
}

//CRCvZhttp://www.w3.org/TR/PNG/#D-CRCAppendix
void makeCRCTable(void)
{
	unsigned long c;
	int i, j;
	for (i=0;i<256;i++) {
		c = (unsigned long) i;
		for (j=0;j<8;j++) {
			if (c & 1) {
				c = 0xedb88320L ^ (c >> 1);
			} else {
				c = c >> 1;
			}
		}
		g_crcTable[i] = c;
	}
	g_crcTableComputed = true;
}
unsigned long updateCRC(unsigned long crc, unsigned char *buf, int len)
{
	unsigned long c = crc;
	int i;
	
	if (!g_crcTableComputed) {
		makeCRCTable();
	}
	for (i=0;i<len;i++) {
		c = g_crcTable[(c^buf[i]) & 0xff] ^ (c >> 8);
	}
	return c;
}
unsigned long getCRC(unsigned char *buf, int len)
{
	return updateCRC(0xffffffffL, buf, len) ^ 0xffffffffL;
}
unsigned long getFileCRC(char *filename)
{
	FILE *fp;
	long len;
	char *buf;
	long crc;
	if ((fp = fopen(filename, "rb")) == NULL) {
		WriteLog(elDebug, "getFileCRC:FileOpenError");
	} else {
		fseek(fp, 0, SEEK_END);
		len = ftell(fp);
		rewind(fp);
		buf = (char *)malloc(len+1);
		fread(buf, sizeof(buf), len, fp);
		crc = getCRC(buf, len);
		fclose(fp);
		free(buf);
	}
	return crc;
}

void strTrim(char *buf)
{
	int i,j;
	for (i=0,j=0;buf[i]!='\0';i++) {
		if (buf[i] == ',') {
			buf[j++] = '.';
		} else if (buf[i] != ' ') {
			buf[j++] = buf[i];
		}
	}
	buf[j] = '\0';
}
void getFileVersion(char *buf, char *filename)
{
	DWORD dwHandle;
	DWORD dwLen;
	dwLen = GetFileVersionInfoSize(filename, &dwHandle);
	strcpy(buf, "0.0.0.0");
	if (dwLen <= 0) {
		return;
	}
	char *lpData = (char *)malloc(dwLen+1);
	if (GetFileVersionInfo(filename, NULL, dwLen, lpData)) {
		UINT verLen;
		DWORD *dwLang;
		char lpSubBlock[100] = "\\VarFileInfo\\Translation";
		if (VerQueryValue(lpData, lpSubBlock, (void **)&dwLang, &verLen)) {
			char lpLang[9];
			LPTSTR lpBuffer;
			sprintf(lpLang, "%04x%04x", LOWORD(*dwLang), HIWORD(*dwLang));
			sprintf(lpSubBlock, "\\StringFileInfo\\%s\\FileVersion", lpLang);
			VerQueryValue(lpData, lpSubBlock, (void **)&lpBuffer, &verLen);
			strcpy(buf, lpBuffer);
			strTrim(buf);
		}
	}
	free(lpData);
}
void getTTBaseVersion(char *buf)	//t@Cƃobt@ӂꂷƎvB
{
	char name[1000];
	char buf2[1000];
	GetModuleFileName(NULL, name, sizeof(name));
	getFileVersion(buf2, name);
	TCHAR path[1024];
	TCHAR *file;
	GetFullPathName(name, sizeof(path)/sizeof(TCHAR), path, &file);
	sprintf(buf, "%s %s", file, buf2);
}

void openText(char *filename)
{
	ShellExecute(NULL, "edit", filename, NULL, NULL, SW_SHOW);
}

void print()
{
	PLUGIN_INFO **pi;
	int i;
	long len;
	char *buf;
	char s[1024];
	char name[256];
	char type[64];
	char crlf[] = "\n";
	char filename[] = "PrintEnvironment_output.txt";
	char ver[64];
	long crc=0;
	FILE *fp, *fp2;
	if ((fp = fopen(filename, "w")) == NULL) {
		WriteLog(elDebug, "FileOpenError");
		return;
	}
	
	pi = TTBPlugin_GetAllPluginInfo();
	
	getOS(s);
	fputs(s, fp);
	fputs(crlf, fp);
	getTTBaseVersion(s);
	fprintf(fp, "TTBase Verion:%s\n\n", s);
	for (i=0;pi[i];i++) {
		if (lstrlen(pi[i]->Name)==0) {
			strcpy(name, "<NONE>");
		} else {
			strcpy(name, pi[i]->Name);
		}
		if (pi[i]->PluginType == 0) {
			strcpy(type, "풓");
		} else if (pi[i]->PluginType == 1) {
			strcpy(type, "풓");
		} else {
			//TTBasepvOCȂ
			continue;
		}
		
		crc = getFileCRC(pi[i]->Filename);
		getFileVersion(ver, pi[i]->Filename);
		
		sprintf(s, "%s\t%s\t%s\t%s\t%X\t%dbytes\n", name, pi[i]->Filename, ver, type, crc, len);
		fputs(s, fp);
	}

	fclose(fp);
	TTBPlugin_FreePluginInfoArray(pi);
	openText(filename);
}

// --------------------------------------------------------
//    vOC[hꂽƂɌĂ΂
// --------------------------------------------------------
BOOL Init(void)
{
	return TRUE;
}

// --------------------------------------------------------
//    vOCA[hꂽƂɌĂ΂
// --------------------------------------------------------
void Unload(void)
{
}

// --------------------------------------------------------
//    R}hsɌĂ΂
// --------------------------------------------------------
BOOL Execute(int CmdId, HWND hWnd)
{
	switch (CmdId) {
	case COMMAND1_ID:
		print();
		break;
	}
	return TRUE;
}

// --------------------------------------------------------
//    O[otbNbZ[WĂ
// --------------------------------------------------------
void Hook(UINT Msg, DWORD wParam, DWORD lParam)
{
}


// --------------------------------------------------------
//    DLLMain
// --------------------------------------------------------
#ifdef __BORLANDC__
#pragma argsused
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void* lpReserved)
{
	g_hInst = hinst;
	return 1;
}
#endif

#if _MSC_VER > 1000
BOOL WINAPI DllMain (HINSTANCE hInstance, DWORD fdwReason, LPVOID lpvReserved)
{
	return TRUE;
}
#endif

